import router from './router'
import store from './store'
import {
  Message
} from 'element-ui'
import NProgress from 'nprogress' // progress bar
import 'nprogress/nprogress.css' // progress bar style

import {
  getToken,
  setToken,
  removeToken
} from '@/utils/auth'
import getPageTitle from '@/utils/get-page-title'

NProgress.configure({
  showSpinner: false
}) // NProgress Configuration

const whiteList = ['/login'] // no redirect whitelist

router.beforeEach(async (to, from, next) => {
  // start progress bar
  NProgress.start()

  // set page title
  document.title = getPageTitle(to.meta.title)

  // determine whether the user has logged in
  // const hasToken = getToken()
  // console.log(hasToken)
  if (localStorage.getItem('wf-pf_admin-token1')) {
    console.log(to.path)
    if (to.path === '/login') {
      // if is logged in, redirect to the home page
      next({
        path: '/'
      })
      NProgress.done()
    } else {
      const hasGetUserInfo = store.getters.name
      // console.log(store.getters)
      if (store.getters.token) {
        if (!whiteList.includes(to.path)) {
          checkLoginUser();
        }
        next();
      } else {
        // try {
          // get user info
          const accessRoutes = await store.dispatch('permission/generateRoutes');
          console.log(to)
          router.addRoutes(accessRoutes);
          // const {
          //   roles
          // } = await store.dispatch('user/getInfo')
          // setToken( 'admin'); 
          store.commit('user/SET_TOKEN', 'admin'); 
          next({
            ...to,
            replace: true
          });
          
        // } catch (error) {
          // remove token and go to login page to re-login
          // await store.dispatch('user/resetToken')
          // Message.error(error || 'Has Error')
          // next(`/login?redirect=${to.path}`)
          // NProgress.done()
        // }
      }
    }
  } else {
    /* has no token*/

    // if (whiteList.indexOf(to.path) !== -1) {
    //   // in the free login whitelist, go directly
    //   next()
    // } else {
    //   // other pages that do not have permission to access are redirected to the login page.
    //   next(`/login?redirect=${to.path}`)
    //   NProgress.done()
    // }
    
    if (whiteList.indexOf(to.path) !== -1) {
      // if(!localStorage.getItem('ws-pf_userId')){
      //   next(getLoginOutUrl() + `?redirect=${to.path}`);
      //   NProgress.done();
      // }else{
        if (!whiteList.includes(to.path)) {
          checkLoginUser();
        }
        next();
      // }
    } else {
      next(getLoginOutUrl() + `?redirect=${to.path}`);
      NProgress.done();
    }
  }
})
function getLoginOutUrl() {
 
  return '/login';
}
function checkLoginUser() {
  if (location.port) {
    return;
  }
}
router.afterEach(() => {
  // finish progress bar
  NProgress.done()
})
